# pylint: disable=no-member
"""Models for input/output."""
import datetime
import enum
import functools
import typing

import pydantic
from pydantic import AfterValidator

from fastapi_bike_sharing.settings import APP_SETTINGS


class Col(str, enum.Enum):
    """Source dataset columns."""

    DATE = "dteday"
    HOUR = "hr"
    HOLIDAY = "holiday"
    WEEKDAY = "weekday"
    WORKING_DAY = "workingday"
    WEATHER = "weathersit"
    TEMPERATURE = "temp"
    FEELING_TEMPERATURE = "atemp"
    HUMIDITY = "hum"
    WIND_SPEED = "windspeed"


class TargetCol(str, enum.Enum):
    """Source dataset target columns."""

    CASUAL_COUNT = "casual"
    REGISTERED_COUNT = "registered"
    TOTAL_COUNT = "cnt"


class NewCol(str, enum.Enum):
    """Additional feature columns."""

    DAY_OF_YEAR = "day_of_year"


def _validate_str_date_format(date_string: str) -> str:
    try:
        datetime.datetime.strptime(date_string, "%Y-%m-%d")  # noqa: DTZ007
    except ValueError as exc:
        raise ValueError("Invalid date format, expected YYYY-MM-DD") from exc
    return date_string


class WeatherType(enum.Enum):
    CLEAR = 1
    MIST = 2
    LIGHT_PRECIPITATION = 3
    HEAVY_PRECIPITATION = 4


def _string_to_weather_type(weather_key: str) -> int:
    weather_key = weather_key.upper()
    if (weather_type := getattr(WeatherType, weather_key, None)) is None:
        raise ValueError(f"Weather type expected to be from {WeatherType}, got {weather_key}.")
    return weather_type.value


MIN_TEMPERATURE: typing.Final[float] = -8.0
MAX_TEMPERATURE: typing.Final[float] = 39.0
MIN_FEELING_TEMPERATURE: typing.Final[float] = -16.0
MAX_FEELING_TEMPERATURE: typing.Final[float] = 50.0
MAX_HUMIDITY: typing.Final[float] = 100.0
MAX_WIND_SPEED: typing.Final[float] = 67.0


def _normalize_value(value: float, *, max_value: float, min_value: float = 0.0) -> float:
    return (value - min_value) / (max_value - min_value)


class BikeDemandParams(pydantic.BaseModel):
    date: typing.Annotated[str, AfterValidator(_validate_str_date_format)]
    hour: typing.Annotated[int, pydantic.confloat(ge=0, le=23)]
    is_holiday: bool
    weather_type: typing.Annotated[
        typing.Literal["clear", "mist", "light_precipitation", "heavy_precipitation"],
        AfterValidator(_string_to_weather_type),
    ]
    temperature_celsius: typing.Annotated[
        float,
        pydantic.confloat(ge=MIN_TEMPERATURE, le=MAX_TEMPERATURE),
        AfterValidator(functools.partial(_normalize_value, min_value=MIN_TEMPERATURE, max_value=MAX_TEMPERATURE)),
    ]
    feeling_temperature_celsius: typing.Annotated[
        float,
        pydantic.confloat(ge=MIN_FEELING_TEMPERATURE, le=MAX_FEELING_TEMPERATURE),
        AfterValidator(
            functools.partial(_normalize_value, min_value=MIN_FEELING_TEMPERATURE, max_value=MAX_FEELING_TEMPERATURE),
        ),
    ]
    humidity: typing.Annotated[
        float,
        pydantic.confloat(ge=0.0, le=MAX_HUMIDITY),
        AfterValidator(functools.partial(_normalize_value, max_value=MAX_HUMIDITY)),
    ]
    wind_speed: typing.Annotated[
        float,
        pydantic.confloat(ge=0.0, le=MAX_WIND_SPEED),
        AfterValidator(functools.partial(_normalize_value, max_value=MAX_WIND_SPEED)),
    ]

    def __hash__(self) -> hash:
        return hash(tuple(self.__dict__.values()))


class BikeDemandRequest(pydantic.BaseModel):
    target_type: TargetCol
    params: list[BikeDemandParams]


class BikeDemandResponse(BikeDemandRequest):
    predicted_demand: list[int]


class DemandTypeResponse(pydantic.BaseModel):
    target_types: dict[str, str] = {
        TargetCol.TOTAL_COUNT: "Total demand generated by both registered and casual users",
        TargetCol.REGISTERED_COUNT: "Demand by registered users only",
        TargetCol.CASUAL_COUNT: "Demand by casual users only",
    }
    weather_types: dict[str, str] = {
        "clear": "Clear, Few clouds, Partly cloudy, Partly cloudy",
        "mist": "Mist + Cloudy, Mist + Broken clouds, Mist + Few clouds, Mist",
        "light_precipitation": "Light Snow, Light Rain + Thunderstorm + Scattered clouds, Light Rain + Scattered clouds",  # noqa: E501
        "heavy_precipitation": "Heavy Rain + Ice Pallets + Thunderstorm + Mist, Snow + Fog",
    }


class HealthCheckResponse(pydantic.BaseModel):
    service_name: str = APP_SETTINGS.service_name
    version: str = APP_SETTINGS.current_version
    status: typing.Literal["ok", "notok"] = "ok"


TEST_PAYLOAD = BikeDemandRequest(
    target_type=TargetCol.TOTAL_COUNT,
    params=[
        BikeDemandParams(
            date="2023-01-01",
            hour=12,
            is_holiday=True,
            weather_type="clear",
            temperature_celsius=6.0,
            feeling_temperature_celsius=3.0,
            humidity=20.0,
            wind_speed=0.5,
        ),
        BikeDemandParams(
            date="2023-06-14",
            hour=18,
            is_holiday=False,
            weather_type="light_precipitation",
            temperature_celsius=17.0,
            feeling_temperature_celsius=14.0,
            humidity=73.0,
            wind_speed=8.5,
        ),
    ],
)
